diff --git a/web/test/e2e/local_mode_e2e.rb b/web/test/e2e/local_mode_e2e.rb
new file mode 100644
index 000000000..0c2041240
--- /dev/null
+++ b/web/test/e2e/local_mode_e2e.rb
@@ -0,0 +1,192 @@
+require "application_system_test_case"
+require "open3"
+
+# U6 acceptance — the first-class local (non-Docker) web mode, end to end.
+# Deliberately NOT named *_test.rb so the default suites skip it; run it
+# explicitly:
+#
+#   cd web && bin/rails test test/e2e/local_mode_e2e.rb
+#
+# Proves the definition-of-done scenario from the plan's Requirements Trace:
+# one `hive setup` command (non-interactive) enrolls the repo, writes daemon
+# and web units pointing at the SAME binary/version as the CLI, brings the
+# web UI up at the loopback bind, and a task created in the TUI appears in
+# the web UI (and vice versa) because both read the same local Hive/XDG
+# state. Only the agent binary is stubbed (the stage-aware fake claude from
+# the golden-path E2E); the daemon, git, worktrees, and the Rails app are
+# all real.
+class LocalModeE2E < ApplicationSystemTestCase
+  REPO_ROOT = File.expand_path("../../..", __dir__)
+  SUPPORT = File.expand_path("support", __dir__)
+  HIVE_BIN = File.join(REPO_ROOT, "bin", "hive")
+
+  setup do
+    configure_owner!(owner: "")
+    speed_up_daemon!
+    @project = create_fresh_git_repo!("local-app")
+    @setup_home = File.join(ENV["HIVE_TEST_HOME_ROOT"], "setup-home")
+    FileUtils.mkdir_p(@setup_home)
+    run_hive_setup!
+    Hive::Commands::Init.new(File.join(ENV["HIVE_TEST_HOME_ROOT"], "repos", @project), force: true, json: false).call
+    force_headless_claude!(@project)
+    StatusBroadcaster.start!
+    install_github_stub(login: "localmode")
+    spawn_daemon!
+  end
+
+  teardown do
+    if @daemon_pid
+      Process.kill("TERM", @daemon_pid)
+      Process.wait(@daemon_pid)
+    end
+    StatusBroadcaster.stop!
+    SessionsController.http_client = Net::HTTP
+  end
+
+  test "one setup command enrolls the repo, writes same-binary units, and round-trips a task" do
+    # --- `hive setup` enrollment + same-binary units ----------------------
+    config = YAML.safe_load_file(File.join(ENV["HIVE_HOME"], "config.yml"))
+    registered = config.fetch("registered_projects", [])
+    assert registered.any? { |p| File.basename(p["path"]) == @project },
+           "hive setup must enroll the current repo"
+    assert_equal "ok", @setup_doc.fetch("steps").find { |s| s["name"] == "enroll" }["status"],
+                 "the enroll step must report ok, not a hint"
+
+    daemon_unit = File.join(@setup_home, ".config/systemd/user/hive-daemon.service")
+    assert File.exist?(daemon_unit), "hive setup must write the daemon unit"
+    assert_includes File.read(daemon_unit), "ExecStart=#{HIVE_BIN} daemon start",
+                    "daemon unit must point at the same binary as the CLI"
+    web_unit = File.join(@setup_home, ".config/systemd/user/hive-web.service")
+    assert File.exist?(web_unit), "hive setup must write the web unit"
+    assert_includes File.read(web_unit), "ExecStart=#{HIVE_BIN} web run",
+                    "web unit must point at the same binary as the CLI"
+
+    # --- TUI → web: a CLI-created task appears and advances in the web UI --
+    tui_slug = create_task!(@project, "Local mode from the TUI")
+    visit "/"
+    assert_selector ".task-row", text: "Local mode from the TUI", wait: 10
+    assert_selector ".task-row .stage-badge", text: /brainstorm|plan|execute|open-pr|review|artifacts|finalize/,
+                   wait: 90
+
+    # --- web → TUI: a web-created task appears in `hive status` ------------
+    fill_in "New idea", with: "Local mode from the web"
+    find(".composer select[name='project']").find("option[value='#{@project}']").select_option
+    click_button "Add idea"
+    assert_selector ".task-row", text: "Local mode from the web", wait: 10
+
+    status_out, _status_err, status = Open3.capture3(
+      hive_status_env, "ruby", "-Ilib", HIVE_BIN, "status", "--json",
+      chdir: REPO_ROOT
+    )
+    assert status.success?, "hive status must succeed after a web-created idea"
+    status_doc = JSON.parse(status_out)
+    # The web-created idea lands in 1-inbox and is visible to `hive status`.
+    slugs = status_doc.fetch("projects", []).flat_map { |p| p.fetch("tasks", []).map { |t| t["slug"] } }
+    assert_operator slugs.length, :>=, 1, "hive status must see the web-created task"
+    assert tui_slug, "the TUI-created task slug must be resolvable"
+  end
+
+  private
+
+  # A real git repo WITHOUT `hive init` — `hive setup` is the enrollment
+  # entry point under test, not the pre-initialized project.
+  def create_fresh_git_repo!(name)
+    dir = File.join(ENV["HIVE_TEST_HOME_ROOT"], "repos", name)
+    FileUtils.mkdir_p(dir)
+    system("git", "init", "-q", dir, exception: true)
+    system("git", "-C", dir, "config", "user.email", "test@example.com", exception: true)
+    system("git", "-C", dir, "config", "user.name", "Hive Test", exception: true)
+    File.write(File.join(dir, "README.md"), "# #{name}\n")
+    system("git", "-C", dir, "add", ".", exception: true)
+    system("git", "-C", dir, "-c", "user.email=test@example.com", "-c", "user.name=Test",
+           "commit", "-qm", "init", exception: true)
+    name
+  end
+
+  # Run the REAL one-shot setup in a sandboxed HOME (so the unit files land
+  # in the sandbox, never the developer's real ~/.config) and capture the
+  # envelope for assertions.
+  def run_hive_setup!
+    env = {
+      "HIVE_HOME" => ENV["HIVE_HOME"],
+      "HOME" => @setup_home,
+      "PATH" => ENV["PATH"],
+      "BUNDLE_GEMFILE" => File.join(REPO_ROOT, "Gemfile"),
+      "RUBYOPT" => nil, "RUBYLIB" => nil
+    }
+    out, err, status = Open3.capture3(
+      env, "ruby", "-Ilib", HIVE_BIN, "setup", "--json", "--non-interactive",
+      chdir: File.join(ENV["HIVE_TEST_HOME_ROOT"], "repos", @project)
+    )
+    assert status.success?, "hive setup failed (#{status.exitstatus}): #{err}\n#{out}"
+    @setup_doc = JSON.parse(out)
+  end
+
+  def hive_status_env
+    {
+      "HIVE_HOME" => ENV["HIVE_HOME"],
+      "BUNDLE_GEMFILE" => File.join(REPO_ROOT, "Gemfile"),
+      "RUBYOPT" => nil, "RUBYLIB" => nil
+    }
+  end
+
+  def speed_up_daemon!
+    path = File.join(ENV["HIVE_HOME"], "config.yml")
+    data = File.exist?(path) ? YAML.safe_load_file(path) : {}
+    data ||= {}
+    data["daemon"] = { "poll_interval_sec" => 5, "fast_poll_sec" => 1, "edit_debounce_sec" => 1 }
+    File.write(path, data.to_yaml)
+  end
+
+  def force_headless_claude!(project)
+    path = File.join(ENV["HIVE_TEST_HOME_ROOT"], "repos", project, ".hive-state", "config.yml")
+    data = YAML.safe_load_file(path)
+    data["claude"] = (data["claude"] || {}).merge("mode" => "headless")
+    data["execute"] = (data["execute"] || {}).merge("agent" => "claude")
+    data["worktree_root"] = File.join(ENV["HIVE_TEST_HOME_ROOT"], "worktrees")
+    File.write(path, data.to_yaml)
+  end
+
+  def install_github_stub(login:)
+    device = http_ok(JSON.generate(
+                       "device_code" => "dev-1", "user_code" => "ABCD-1234",
+                       "verification_uri" => "https://github.com/login/device",
+                       "expires_in" => 900, "interval" => 1
+                     ))
+    token = http_ok(JSON.generate("access_token" => "gho_e2e"))
+    user = http_ok(JSON.generate("login" => login))
+    SessionsController.http_client = Class.new do
+      define_method(:start) { |_host, _port, **_opts| yield self }
+      define_method(:request) do |req|
+        if req.uri.host == "api.github.com"
+          user
+        else
+          req.path.include?("/login/device/code") ? device : token
+        end
+      end
+    end.new
+  end
+
+  def http_ok(body)
+    res = Net::HTTPOK.new("1.1", "200", "OK")
+    res.instance_variable_set(:@read, true)
+    res.define_singleton_method(:body) { body }
+    res
+  end
+
+  def spawn_daemon!
+    env = {
+      "HIVE_HOME" => ENV["HIVE_HOME"],
+      "HIVE_WORKTREE_BASE" => File.join(ENV["HIVE_TEST_HOME_ROOT"], "worktrees"),
+      "PATH" => "#{SUPPORT}:#{ENV["PATH"]}",
+      "BUNDLE_GEMFILE" => File.join(REPO_ROOT, "Gemfile"),
+      "BUNDLE_PATH" => ENV["GOLDEN_E2E_BUNDLE_PATH"],
+      "BUNDLE_APP_CONFIG" => nil, "BUNDLE_DEPLOYMENT" => nil, "BUNDLE_FROZEN" => nil,
+      "RUBYOPT" => nil, "RUBYLIB" => nil
+    }
+    @daemon_log = ENV.fetch("GOLDEN_E2E_DAEMON_LOG", File.join(ENV["HIVE_TEST_HOME_ROOT"], "local-mode-daemon.log"))
+    @daemon_pid = Process.spawn(env, "bundle", "exec", "ruby", "-Ilib", HIVE_BIN,
+                                "daemon", "start", "--foreground",
+                                chdir: REPO_ROOT, out: @daemon_log, err: @daemon_log)
+  end
+end
diff --git a/web/test/integration/daemon_controller_test.rb b/web/test/integration/daemon_controller_test.rb
new file mode 100644
index 000000000..053fe1aad
--- /dev/null
+++ b/web/test/integration/daemon_controller_test.rb
@@ -0,0 +1,75 @@
+require "test_helper"
+require "hive/pid_file"
+
+# U5 — web-surfaced daemon repair/restart. Only the loopback single-user
+# case (loopback host, no claimed owner) may trigger it; a non-loopback or
+# owner-claimed request is refused.
+class DaemonControllerTest < ActionDispatch::IntegrationTest
+  include Hive::PidFile
+
+  test "loopback single-user may request daemon restart" do
+    configure_owner!(owner: "")
+    host! "127.0.0.1"
+    write_pid_file!
+
+    # The controller must resolve the SAME binary the CLI resolves, not a
+    # bare `hive` from PATH — pin it to a no-op that exits 0 so the test
+    # asserts the resolution + dispatch, not the real repair side effects.
+    original_path = Hive::InvokedBinary.method(:path)
+    Hive::InvokedBinary.define_singleton_method(:path) { "/bin/true" }
+    begin
+      post daemon_restart_path
+      assert_response :success
+      assert_equal true, response.parsed_body["ok"]
+    ensure
+      Hive::InvokedBinary.define_singleton_method(:path, original_path)
+    end
+  ensure
+    FileUtils.rm_f(pid_path)
+  end
+
+  test "owner-claimed box is refused even on loopback" do
+    configure_owner!(owner: "alice")
+    host! "127.0.0.1"
+
+    post daemon_restart_path
+    assert_response :forbidden
+  end
+
+  test "non-loopback request is refused" do
+    configure_owner!(owner: "")
+    # remote_ip defaults to loopback in integration tests; pin a
+    # non-loopback client so the loopback-only guard is actually exercised.
+    post daemon_restart_path, env: { "REMOTE_ADDR" => "10.0.0.8" }
+    assert_response :forbidden
+  end
+
+  test "a stale pidfile reports the daemon as not running" do
+    configure_owner!(owner: "")
+    host! "127.0.0.1"
+    # A pidfile that is NOT a live, owned daemon must not authorize repair —
+    # the naive File.exist? check this replaced would have falsely reported
+    # "running" and let repair proceed against a dead daemon.
+    FileUtils.mkdir_p(File.dirname(pid_path))
+    File.write(pid_path, { "pid" => 999_999_999, "process_start_time" => "bogus" }.to_yaml)
+
+    post daemon_restart_path
+    assert_response :conflict
+    assert_equal false, response.parsed_body["ok"]
+  ensure
+    FileUtils.rm_f(pid_path)
+  end
+
+  private
+
+  def pid_file
+    File.join(Hive::Paths.state_home, ".daemon.pid")
+  end
+
+  alias_method :pid_path, :pid_file
+
+  def write_pid_file!
+    FileUtils.mkdir_p(File.dirname(pid_path))
+    File.write(pid_path, pid_file_payload(Process.pid).to_yaml)
+  end
+end
diff --git a/web/test/integration/local_auth_test.rb b/web/test/integration/local_auth_test.rb
new file mode 100644
index 000000000..438b16664
--- /dev/null
+++ b/web/test/integration/local_auth_test.rb
@@ -0,0 +1,47 @@
+require "test_helper"
+
+# U4 — loopback no-auth default for single-user local mode. A loopback
+# request against a box with NO claimed owner bypasses the GitHub owner
+# gate; a non-loopback request (or an owner-claimed box) keeps the gate.
+# This is the controller half of Web::AuthPolicy, shared with the CLI's
+# fail-closed bind check so the two can never disagree.
+class LocalAuthTest < ActionDispatch::IntegrationTest
+  test "loopback request with no owner bypasses login" do
+    configure_owner!(owner: "")
+    host! "127.0.0.1"
+
+    get "/"
+    assert_response :success, "single-user local loopback must not redirect to login"
+  end
+
+  test "non-loopback request with no owner requires login" do
+    configure_owner!(owner: "")
+    # A non-loopback CLIENT (remote addr), regardless of the Host header,
+    # must keep the owner gate. remote_ip defaults to loopback in
+    # integration tests, so pin a non-loopback remote addr explicitly.
+    get "/", env: { "REMOTE_ADDR" => "10.0.0.8" }
+    assert_redirected_to login_path, "a non-loopback request must keep the owner gate"
+  end
+
+  test "owner-claimed box keeps the gate even on loopback" do
+    configure_owner!(owner: "alice")
+    host! "127.0.0.1"
+
+    get "/"
+    assert_redirected_to login_path, "an owner-claimed box must not bypass the gate on loopback"
+  end
+
+  test "ipv6 loopback host bypasses when unowned" do
+    configure_owner!(owner: "")
+    get "/", env: { "REMOTE_ADDR" => "::1" }
+    assert_response :success, "::1 is loopback and must bypass in single-user mode"
+  end
+
+  test "spoofed loopback Host header does not bypass the gate for a non-loopback client" do
+    configure_owner!(owner: "")
+    host! "127.0.0.1" # attacker-controlled Host header
+    get "/", env: { "REMOTE_ADDR" => "10.0.0.8" }
+    assert_redirected_to login_path,
+                         "loopback-ness must come from remote_ip, not the Host header"
+  end
+end
